<?php
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
include_once $path.'/Model_adm.php';
$webp_name = 'website';
//Inclusion des librairie
// include_once $path.'common.php';
$_GET['nodeid'] = $_REQUEST['node'];

/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
					'name'=>$node->getName(),
					'ip'=>$node->getIPAddress(),
					'id'=>$node->getId(),
					'description'=>$node->getDescription(),
					'group'=>$node->getGroup());
 * SMARTY
		$webp_name nom du plugin
		$node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */

$node_id = $_REQUEST['node']; //11
if(!isset($_REQUEST['node']))
{

	// $credentials['url'] = $_POST['api_url'];
	$node_id = $setting['node_id'];

}

include_once $path.'/inc/common_node_control.php';

$action = 'list';

if(isset($_GET['action']) && !empty($_GET['action']))
{
	$action = $_GET['action'];
}

	$adv_config_id = $_REQUEST['id']; //6
	$my_url = trim($_POST['advurl'],'/');

		$setting = Model_adm::getAdvanceNodeConfig($dbconnection,NULL,$adv_config_id)[0];
		if(!empty($_POST['advurl']))
		{
			$smarty->assign('url_rec',$my_url);
		}
		else {
			$smarty->assign('url_rec',$setting['parameter']['type']);
		}




	if($action == "add")
	{
	   /* $plugin = Model_esia::getPlugin($dbconnection,'CHECK_API_IP_LABEL_SYNC');
		$plugin = $plugin[0];
		Model_adm::addService($dbconnection,'CHECK_API_IP_LABEL_SYNC',$plugin['id'],$node_id,300000,'-A $AUTH_FILE_IPLABEL -t sync -w 15 -c 30',2,null,null,null,null,null);*/

		// Model_adm::AddAdvanceNodeConfig($dbconnection,$adv_config_id,3, $clear_json); ///
	}

	if($action == "update" || $action == "add")
	{

		  $smarty->assign('adv_id',$adv_config_id); //6

      $smarty->assign('nodeid',$node_id); //11
        try
        {
				if(!empty($_REQUEST['advurl']))
				{
					$crd = $my_url;
	                $clear_json = json_encode($crd);

	                $smarty->assign('clear_json',$clear_json);
	                preg_match($crd, '#(http(s)?)://[^/]+#',$matches);

	                  $https_param='';
	                  if($crd == 443 || !empty($matches[2])){
	                    $https_param=' -S';
	                  }
	                  $pl_http_params='-H '.$matches[3]."$https_param -p".$crd;

	                  $array=array('type'=>$crd);
	                  Model_adm::updateAdvanceNodeConfig($dbconnection,$adv_config_id,json_encode($array));
	                  $smarty->assign('ADM_MESSAGE',array(array('message'=>$lang['WEBSITE_URL_CONFIMATION'])));
	                  // exit(0);
				  }
                  $res = Model_adm::getAdvanceNodeConfig($dbconnection,NULL,$adv_config_id)[0];

        }
        catch(Exception $ex)
        {
            $ERRORS[]= array('name'=>'DB error' ,'message'=>$ex->getMessage());
            $smarty->assign('ERRORS',$ERRORS);
        }
        $urlsearch = loadSettings($dbconnection,$adv_id);


        $nodeIN = Model_esia::InstanceNode($dbconnection,$node_id);

        
        if(!empty($_POST['advurl']))
        {
            if($nodeIN->getType()=='gesa')
            {
              // ajouter les servises du types gesa (Unity)
                $webs_service = Model_esia::getServices($dbconnection,$node_id);

                // La condition sur les services (s'il existe déja ou pas)
                $service_GESA_HTTP = true;
                $service_GESA_DNS =  true;
                $service_GESA_HTTPS_CERTIFICATE_EXPIRE =  true;
                foreach ($webs_service as $value)
                {
                	if($value['name']== 'GESA_HTTP')
                	{
                		$service_GESA_HTTP =  false;
                    $srvc_http_id = $value['id'];
                	}
                  	if($value['name']== 'GESA_DNS')
                	{
                		$service_GESA_DNS =  false;
                    $srvc_dns_id = $value['id'];
                	}
                  	if($value['name']== 'GESA_HTTPS_CERTIFICATE_EXPIRE')
                	{
                		$service_GESA_HTTPS_CERTIFICATE_EXPIRE =  false;
                    $srvc_certificate_expire_id = $value['id'];
                	}
                	if($value['name']== 'GESA_QUALYS')
                	{
                		$service_GESA_QUALYS =  false;
                		$srvc_qualys_id = $value['id'];
                	}
                }

                $adv_url = $my_url;
                $adv_url = preg_replace('#^(http|https)://#','',$adv_url);

                    if($service_GESA_HTTP)
                    {
                        $plugin = Model_esia::getPlugin($dbconnection,'GESA_HTTP');
              		      $plugin = $plugin[0];

                        $url_param = preg_replace('/^-H\s+\W\w+/','-H '.$adv_url.'',$plugin['parameter']);
                        // if($url_param[0].$url_param[1].$url_param[2].$url_param[3]="http")
                        // {
                            // $url_param = preg_replace('#^http#','',$url_param);
                            Model_adm::addService($dbconnection,'GESA_HTTP',$plugin['id'],$node_id,300000,$url_param,2,null,null,null,null,null);
                        // }
                    }
                    else
                    {
                        $plugin = Model_esia::getPlugin($dbconnection,'GESA_HTTP');
              		      $plugin = $plugin[0];



                        $url_param = preg_replace('/^-H\s+\W\w+/','-H '.$adv_url.'',$plugin['parameter']);
                        Model_adm::updateservice($dbconnection,$srvc_http_id,'GESA_HTTP',$plugin['id'],$node_id,300000,$url_param,2,null,null,null,null,null);
                    }

                    if($service_GESA_DNS)
                    {
                        $plugin = Model_esia::getPlugin($dbconnection,'GESA_DNS');
              		      $plugin = $plugin[0];
                        $tmp = preg_replace('#\-s\s+[0-9\$\.a-zA-Z]*#','',$plugin['parameter']);
                        $tmp = preg_replace('#\-H\s+\<host\>#',' -H '.$adv_url,$tmp);
                        $tmp = trim($tmp);
                        Model_adm::addService($dbconnection,'GESA_DNS',$plugin['id'],$node_id,300000,$tmp,2,null,null,null,null,null);
                    }
                    else
                    {
                        $plugin = Model_esia::getPlugin($dbconnection,'GESA_DNS');
              		      $plugin = $plugin[0];
                        $tmp = preg_replace('#\-s\s+[0-9\$\.a-zA-Z]*#','',$plugin['parameter']);
                        $tmp = preg_replace('#\-H\s+\<host\>#',' -H '.$adv_url,$tmp);
                        $tmp = trim($tmp);
                        Model_adm::updateservice($dbconnection,$srvc_dns_id,'GESA_DNS',$plugin['id'],$node_id,300000,$tmp,2,null,null,null,null,null);
                    }


                    if($service_GESA_HTTPS_CERTIFICATE_EXPIRE)
                    {
                        $plugin = Model_esia::getPlugin($dbconnection,'GESA_HTTPS_CERTIFICATE_EXPIRE');
              		      $plugin = $plugin[0];

                        $url_param = preg_replace('/^-H\s+\W\w+/','-H '.$adv_url.'',$plugin['parameter']);
                        Model_adm::addService($dbconnection,'GESA_HTTPS_CERTIFICATE_EXPIRE',$plugin['id'],$node_id,300000,$url_param,2,null,null,null,null,null);
                    }
                    else
                    {
                        $plugin = Model_esia::getPlugin($dbconnection,'GESA_HTTPS_CERTIFICATE_EXPIRE');
              		      $plugin = $plugin[0];
                        $url_param = preg_replace('/^-H\s+\W\w+/','-H '.$adv_url.'',$plugin['parameter']);
                        Model_adm::updateservice($dbconnection,$srvc_certificate_expire_id,'GESA_HTTPS_CERTIFICATE_EXPIRE',$plugin['id'],$node_id,300000,$url_param,2,null,null,null,null,null);
                    }
                    if($service_GESA_QUALYS)
                    {
                    	$plugin = Model_esia::getPlugin($dbconnection,'GESA_QUALYS');
                    	$plugin = $plugin[0];
                    	$url_param = preg_replace('#^-u\s<url site web>#','-u '.$url_iframe.'',$plugin['parameter']);
                    	Model_adm::addService($dbconnection,'GESA_QUALYS',$plugin['id'],$_GET["nodeid"],300000,$url_param,2,null,null,null,null,null);
                    }
                    else
                    {
                    	$plugin = Model_esia::getPlugin($dbconnection,'GESA_QUALYS');
                    	$plugin = $plugin[0];
                    	$url_param = preg_replace('#^-u\s<url site web>#','-u '.$url_iframe.'',$plugin['parameter']);
                    	Model_adm::updateservice($dbconnection,$srvc_qualys_id,'GESA_QUALYS',$plugin['id'],$_GET["nodeid"],300000,$url_param,2,null,null,null,null,null);
                    }

            }
            else
            {
                // Ajouter les services du types check
                $webs_service = Model_esia::getServices($dbconnection,$node_id);


                // La condition sur les services (s'il existe déja ou pas)
                $service_CHECK_HTTP = true;
                $service_CHECK_DNS =  true;
                $service_CHECK_HTTPS_CERTIFICATE_EXPIRE =  true;
                $service_CHECK_QUALYS = true;
                foreach ($webs_service as $value )
                {
                	if($value['name']== 'CHECK_HTTP')
                	{
                		$service_CHECK_HTTP =  false;
                    $srvc_http_id = $value['id'];
                	}
                  if($value['name']== 'CHECK_DNS')
                	{
                		$service_CHECK_DNS =  false;
                    $srvc_dns_id = $value['id'];
                	}
                  if($value['name']== 'CHECK_HTTPS_CERTIFICATE_EXPIRE')
                	{
                		$service_CHECK_HTTPS_CERTIFICATE_EXPIRE =  false;
                    $srvc_certificate_expire_id = $value['id'];
                	}
                	if($value['name']== 'CHECK_HTTP_QUALYS_CERTIFICATE')
                	{
                		$service_CHECK_QUALYS =  false;
                		$srvc_qualys_id = $value['id'];
                	}
                }


                $adv_url = $my_url;
                $adv_url = preg_replace('#^(http|https)://#','',$adv_url);

                    if($service_CHECK_HTTP)
                    {
                        $plugin = Model_esia::getPlugin($dbconnection,'CHECK_HTTP');
              		      $plugin = $plugin[0];

                        $url_param = preg_replace('/^-H\s+\W\w+/','-H '.$adv_url.'',$plugin['parameter']);
                        // if($url_param[0].$url_param[1].$url_param[2].$url_param[3]="http")
                        // {
                            // $url_param = preg_replace('#^http#','',$url_param);
                            Model_adm::addService($dbconnection,'CHECK_HTTP',$plugin['id'],$node_id,300000,$url_param,2,null,null,null,null,null);
                        // }
                    }
                    else
                    {
                        $plugin = Model_esia::getPlugin($dbconnection,'CHECK_HTTP');
              		      $plugin = $plugin[0];

                        $url_param = preg_replace('/^-H\s+\W\w+/','-H '.$adv_url.'',$plugin['parameter']);
                        Model_adm::updateservice($dbconnection,$srvc_http_id,'CHECK_HTTP',$plugin['id'],$node_id,300000,$url_param,2,null,null,null,null,null);
                    }

                    if($service_CHECK_DNS)
                    {
                        $plugin = Model_esia::getPlugin($dbconnection,'CHECK_DNS');
              		      $plugin = $plugin[0];
                        $tmp = preg_replace('#\-s\s+[0-9\$\.a-zA-Z]*#','',$plugin['parameter']);
                        $tmp = preg_replace('#\-H\s+\<host\>#',' -H '.$adv_url,$tmp);
                        $tmp = trim($tmp);
                        Model_adm::addService($dbconnection,'CHECK_DNS',$plugin['id'],$node_id,300000,$tmp,2,null,null,null,null,null);
                    }
                    else
                    {
                        $plugin = Model_esia::getPlugin($dbconnection,'CHECK_DNS');
              		      $plugin = $plugin[0];
                        $tmp = preg_replace('#\-s\s+[0-9\$\.a-zA-Z]*#','',$plugin['parameter']);
                        $tmp = preg_replace('#\-H\s+\<host\>#',' -H '.$adv_url,$tmp);
                        $tmp = trim($tmp);
                        Model_adm::updateservice($dbconnection,$srvc_dns_id,'CHECK_DNS',$plugin['id'],$node_id,300000,$tmp,2,null,null,null,null,null);
                    }


                    if($service_CHECK_HTTPS_CERTIFICATE_EXPIRE)
                    {
                        $plugin = Model_esia::getPlugin($dbconnection,'CHECK_HTTPS_CERTIFICATE_EXPIRE');
              		      $plugin = $plugin[0];

                        $url_param = preg_replace('/^-H\s+\W\w+/','-H '.$adv_url.'',$plugin['parameter']);
                        Model_adm::addService($dbconnection,'CHECK_HTTPS_CERTIFICATE_EXPIRE',$plugin['id'],$node_id,300000,$url_param,2,null,null,null,null,null);
                    }
                    else
                    {
                        $plugin = Model_esia::getPlugin($dbconnection,'CHECK_HTTPS_CERTIFICATE_EXPIRE');
              		      $plugin = $plugin[0];
                        $url_param = preg_replace('/^-H\s+\W\w+/','-H '.$adv_url.'',$plugin['parameter']);
                        Model_adm::updateservice($dbconnection,$srvc_certificate_expire_id,'CHECK_HTTPS_CERTIFICATE_EXPIRE',$plugin['id'],$node_id,300000,$url_param,2,null,null,null,null,null);
                    }
                    
                    if($service_CHECK_QUALYS)
                    {
                    	$plugin = Model_esia::getPlugin($dbconnection,'CHECK_HTTP_QUALYS_CERTIFICATE');
                    	$plugin = $plugin[0];
                    	$url_param = preg_replace('#^-u\s<url site web>#','-u '.$adv_url.'',$plugin['parameter']);
                    	Model_adm::addService($dbconnection,'CHECK_HTTP_QUALYS_CERTIFICATE',$plugin['id'],$node_id,300000,$url_param,2,null,null,null,null,null);
                    }
                    else
                    {
                    	$plugin = Model_esia::getPlugin($dbconnection,'CHECK_HTTP_QUALYS_CERTIFICATE');
                    	$plugin = $plugin[0];
                    	$url_param = preg_replace('#^-u\s<url site web>#','-u '.$adv_url.'',$plugin['parameter']);
                    	Model_adm::updateservice($dbconnection,$srvc_qualys_id,'CHECK_HTTP_QUALYS_CERTIFICATE',$plugin['id'],$node_id,300000,$url_param,2,null,null,null,null,null);
                    }
            }
        }
        $smarty->assign('api_param_url',$urlsearch['url']);
        $smarty->assign('url',$setting['web_plugin_path'].$setting['controller']);
		$smarty->display($template_path.'/adv_'.$webp_name.'.html');

    }
?>
